#ifndef _amc1_dev_header_h_
#define _amc1_dev_header_h_

#include <stdint.h>

#define FLAG_LOOP 0b01000000
#define FLAG_TRAP 0b10000000

typedef struct {
    uint8_t ip;
    uint8_t flags;
    int8_t memory[256];
} amc1_t; 

typedef enum {
    OP_NOOP = 0,
    OP_INV  = 1,
    OP_ADD  = 2,
    OP_SUB  = 3,
    OP_MUL,
    OP_DIV,
    OP_MOD,
    OP_AND,
    OP_OR,
    OP_PRINT,
    OP_JUMP,
    OP_JGZ,
    OP_JLZ,
    OP_JEZ,
    OP_JNZ,
    OP_JGE,
    OP_JLE,
    OP_BRK,
    OP_EXIT 
} eOps;

void init_AMC1(amc1_t* AMC1, uint8_t flags);
#endif
